<?php
/*
    Plugin Name: WebRotate 360 Product Viewer for WordPress
    Plugin URI: http://www.webrotate360.com/360-product-viewer.html
    Description: WebRotate 360 Product Viewer WordPress Integration
    Version: 3.0
    Author: WebRotate 360 LLC
    Author URI: http://www.webrotate360.com
    License: GPLv2
*/

if (!defined("ABSPATH"))
    exit;

class WR360ShortCodes
{
    public function __construct()
    {
        add_shortcode("wr360embed", array($this, "add_embed_shortcode_hanlder"));
        add_shortcode("wr360popup", array($this, "add_popup_shortcode_hanlder"));
        add_shortcode("wr360expand", array($this, "add_expand_shortcode_hanlder"));
    }

    public function add_popup_shortcode_hanlder($atts, $content)
    {
        $defConfig = new WR360DefaultsConfig();
        $defConfig->init_shortcode($atts);

        if ($defConfig->isPopupGallery)
        {
            $replace = "<a id='%s' href='%s?config=%s&amp;root=%s&amp;height=%s&amp;viewname=%s&amp;iframe=true&amp;width=%s&amp;height=%s&amp;' data-rel=prettyPhoto[iframe]>";
        }
        else
        {
            $replace = "<a id='%s' href='%s?config=%s&amp;root=%s&amp;height=%s&amp;viewname=%s&amp;iframe=true&amp;width=%s&amp;height=%s&amp;' data-rel=prettyPhoto>";
        }

        $replace .= $content;
        $replace .= "</a>";

        return (sprintf(
            $replace,
            'wr360_' . $defConfig->name,
            plugins_url("webrotate-360-product-viewer/public/viewloader_" . $defConfig->viewerSkin . ".html"),
            urlencode($defConfig->config),
            urlencode($defConfig->rootPath),
            $defConfig->viewerHeight,
            $defConfig->name,
            str_ireplace("%", "", $defConfig->viewerWidth),
            $defConfig->viewerHeight));
    }

    public function add_expand_shortcode_hanlder($atts, $content)
    {
        $defConfig = new WR360DefaultsConfig();
        $defConfig->init_shortcode($atts);

        $replace  = "<div id='%s' style='cursor:pointer;'>";
        $replace .= "<script language='javascript' type='text/javascript'>";
        $replace .= "jQuery(document).ready(function(){jQuery('#' + '%s').rotator({fullScreenOnClick:true, graphicsPath:'%s', licenseFileURL:'%s', rootPath:'%s', configFileURL:'%s', zIndexLayersOn:%s, googleEventTracking:%s, viewName:'%s'});});";
        $replace .= "</script>";
        $replace .= $content;
        $replace .= "</div>";

        return (sprintf(
            $replace,
            "wr360_" . $defConfig->name . "_playerid",
            'wr360_' . $defConfig->name . "_playerid",
            plugins_url("webrotate-360-product-viewer/imagerotator/html/img/" . $defConfig->viewerSkin),
            $defConfig->licensePath,
            $defConfig->rootPath,
            $defConfig->config,
            $defConfig->zIndexLayers    ? "true" : "false",
            $defConfig->useGoogleEvents ? "true" : "false",
            $defConfig->name));
    }

    public function add_embed_shortcode_hanlder($atts, $content)
    {
        $defConfig = new WR360DefaultsConfig();
        $defConfig->init_shortcode($atts);

        $replace  = "";
        $replace .= "<div id='%s' class='webrotate360' style='width:%s; height:%s;'>";
        $replace .= "<div id='%s' class='wr360_player'></div></div>";
        $replace .= "<script language='javascript' type='text/javascript'>";
        $replace .= "jQuery(document).ready(function(){jQuery('#' + '%s').rotator({apiReadyCallback: function(api){var fn = window['%s']; if(typeof fn === 'function'){fn('%s', api);}}, graphicsPath:'%s', licenseFileURL:'%s', rootPath:'%s', configFileURL:'%s', responsiveBaseWidth:%s, zIndexLayersOn:%s, googleEventTracking:%s, viewName:'%s'});});";
        $replace .= "</script>";

        return (sprintf(
            $replace,
            'wr360_' . $defConfig->name,
            (strpos($defConfig->viewerWidth, '%') === FALSE) ? $defConfig->viewerWidth . 'px' : $defConfig->viewerWidth,
            $defConfig->viewerHeight . "px",
            'wr360_' . $defConfig->name .'_playerid',
            'wr360_' . $defConfig->name .'_playerid',
            $defConfig->callback,
            $defConfig->name,
            plugins_url("webrotate-360-product-viewer/imagerotator/html/img/" . $defConfig->viewerSkin),
            $defConfig->licensePath,
            $defConfig->rootPath,
            $defConfig->config,
            $defConfig->baseWidth,
            $defConfig->zIndexLayers    ? "true" : "false",
            $defConfig->useGoogleEvents ? "true" : "false",
            $defConfig->name));
    }
}
